
%  srs_distance_atten_ramp_plateau.m  ver 1.0  by Tom Irvine

function[f,a]=srs_distance_atten_ramp_plateau(attp,attr,f,a)

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

aamax_reduced=max(a)*attp;

%  out1=sprintf('\n  aamax_reduced=%g  max(a)=%g  attp=%g   \n',aamax_reduced,max(a),attp);
%  disp(out1);


fr=f;
r=a*attr;

[s,num]=calculate_slopes(fr,r);

octave=(1/784);
noct_limit=4*(1/96);

[f,spec]=octave_interpolation(octave,fr,r,s,num);

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

LF=length(f);

ia=zeros(LF,1);

for i=1:LF

    if(spec(i)>=aamax_reduced)
        spec(i)=aamax_reduced;
        ia(i)=i;
    end
    
end

for i=2:LF
    if(ia(i-1)==0 && ia(i)==1)
        n=log10(spec(i)/spec(i-1))/log10(f(i)/f(i-1));
        f(i)=f(i-1)*(spec(i)/spec(i-1))^(1/n);  
    end
end

for i=1:LF-1
    if(ia(i)==1 && ia(i+1)==0)
        n=log10(spec(i+1)/spec(i))/log10(f(i+1)/f(i));
        f(i+1)=f(i)*(spec(i+1)/spec(i))^(1/n);  
    end
end

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

for i=(LF-1):-1:2
    n1=log10(spec(i)/spec(i-1))/log10(f(i)/f(i-1));
    n2=log10(spec(i+1)/spec(i))/log10(f(i+1)/f(i));
  
    noct=log(f(i+1)/f(i))/log(2); 

    if((abs(n1-n2)<0.1) || noct<noct_limit)
        f(i)=[];
        spec(i)=[];
    end
end

a=spec;

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

f=fix_size(f);
a=fix_size(a);